<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__sysclk__wco__funcs" kind="group">
    <compoundname>group_sysclk_wco_funcs</compoundname>
    <title>Functions</title>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__sysclk__wco__funcs_1gac7a1668667e226fd74f782d965b9cd1d" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>__STATIC_INLINE <ref kindref="member" refid="group__group__sysclk__returns_1gad6699a184e2e3c01433251b0981558f3">cy_en_sysclk_status_t</ref></type>
        <definition>__STATIC_INLINE cy_en_sysclk_status_t Cy_SysClk_WcoEnable</definition>
        <argsstring>(uint32_t timeoutus)</argsstring>
        <name>Cy_SysClk_WcoEnable</name>
        <param>
          <type>uint32_t</type>
          <declname>timeoutus</declname>
        </param>
        <briefdescription>
<para>Enables the WCO. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>timeoutus</parametername>
</parameternamelist>
<parameterdescription>
<para>amount of time in microseconds to wait for the WCO to be ready. If WCO is not ready, WCO is stopped. To avoid waiting for WCO ready set this to 0, and manually check if WCO is okay using <ref kindref="member" refid="group__group__sysclk__wco__funcs_1ga566c56a125f99d63b8f39f24e11bc1f9">Cy_SysClk_WcoOkay</ref>.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Error / status code: <linebreak />
CY_SYSCLK_SUCCESS - WCO successfully enabled <linebreak />
CY_SYSCLK_TIMEOUT - Timeout waiting for WCO to stabilize CY_SYSCLK_INVALID_STATE - ECO already enabled For the PSoC 64 devices there are possible situations when function returns the PRA error status code. This is because for PSoC 64 devices the function uses the PRA driver to change the protected registers. Refer to <ref kindref="member" refid="group__group__pra__enums_1ga60be13e12e82986f8c0d6c6a6d4f12c5">cy_en_pra_status_t</ref> for more details.</para></simplesect>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />The<sp />WCO<sp />needs<sp />to<sp />source<sp />the<sp />backup<sp />clock<sp />for<sp />the<sp />real-time<sp />clock</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />operation.<sp />Timeout<sp />of<sp />2ms<sp />is<sp />tolerable.<sp />The<sp />WCO<sp />pins<sp />are<sp />configured</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />using<sp />the<sp />gpio<sp />driver(SRSS_WCO_IN_PIN,<sp />SRSS_WCO_OUT_PIN).<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />the<sp />WCO<sp />with<sp />a<sp />timeout<sp />of<sp />2000<sp />microseconds<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__sysclk__returns_1ggad6699a184e2e3c01433251b0981558f3a1563f761f963757b339ff05eb5a690ec">CY_SYSCLK_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__sysclk__wco__funcs_1gac7a1668667e226fd74f782d965b9cd1d">Cy_SysClk_WcoEnable</ref>(2000))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Insert<sp />error<sp />handling<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />the<sp />backup<sp />clock<sp />source<sp />to<sp />WCO<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__sysclk__clk__bak__funcs_1ga09031ac63142fe0837f87fb5dabea7a5">Cy_SysClk_ClkBakSetSource</ref>(<ref kindref="member" refid="group__group__sysclk__clk__bak__enums_1ggae43abac127a973232c6e4c1adbde0497a9a82c90148622105cc000167a9b0428b">CY_SYSCLK_BAK_IN_WCO</ref>);</highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="1743" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_sysclk.h" bodystart="1720" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_sysclk.h" line="1691" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__sysclk__wco__funcs_1ga566c56a125f99d63b8f39f24e11bc1f9" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>__STATIC_INLINE bool</type>
        <definition>__STATIC_INLINE bool Cy_SysClk_WcoOkay</definition>
        <argsstring>(void)</argsstring>
        <name>Cy_SysClk_WcoOkay</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Reports the status of the WCO_OK bit. </para>        </briefdescription>
        <detaileddescription>
<para><simplesect kind="return"><para>true = okay <linebreak />
false = not okay</para></simplesect>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />The<sp />WCO<sp />needs<sp />to<sp />source<sp />the<sp />backup<sp />clock<sp />for<sp />the<sp />real-time</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />clock<sp />operation.<sp />It<sp />needs<sp />to<sp />be<sp />enabled<sp />in<sp />a<sp />non-blocking</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />manner.<sp />The<sp />WCO<sp />pins<sp />are<sp />configured<sp />using<sp />the<sp />gpio<sp />driver</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(SRSS_WCO_IN_PIN,<sp />SRSS_WCO_OUT_PIN).<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />the<sp />WCO<sp />without<sp />timeout<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)<ref kindref="member" refid="group__group__sysclk__wco__funcs_1gac7a1668667e226fd74f782d965b9cd1d">Cy_SysClk_WcoEnable</ref>(0UL);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal">(!<ref kindref="member" refid="group__group__sysclk__wco__funcs_1ga566c56a125f99d63b8f39f24e11bc1f9">Cy_SysClk_WcoOkay</ref>())</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />WCO<sp />is<sp />not<sp />yet<sp />ready.<sp />Perform<sp />some<sp />other<sp />operation.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />the<sp />backup<sp />clock<sp />source<sp />to<sp />WCO<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__sysclk__clk__bak__funcs_1ga09031ac63142fe0837f87fb5dabea7a5">Cy_SysClk_ClkBakSetSource</ref>(<ref kindref="member" refid="group__group__sysclk__clk__bak__enums_1ggae43abac127a973232c6e4c1adbde0497a9a82c90148622105cc000167a9b0428b">CY_SYSCLK_BAK_IN_WCO</ref>);</highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="1763" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_sysclk.h" bodystart="1760" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_sysclk.h" line="1692" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__sysclk__wco__funcs_1ga855b936e5f17dc77abd2c44ec0660e2a" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>__STATIC_INLINE void</type>
        <definition>__STATIC_INLINE void Cy_SysClk_WcoDisable</definition>
        <argsstring>(void)</argsstring>
        <name>Cy_SysClk_WcoDisable</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Disables the WCO. </para>        </briefdescription>
        <detaileddescription>
<para><simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />LFCLK<sp />needs<sp />to<sp />be<sp />sourced<sp />by<sp />the<sp />PILO<sp />instead<sp />of<sp />the<sp />WCO.<sp />All</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />peripherals<sp />clocked<sp />by<sp />the<sp />LFCLK<sp />are<sp />disabled<sp />and<sp />the<sp />Watchdog</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />timer<sp />(WDT)<sp />is<sp />unlocked.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Disable<sp />the<sp />WCO<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__sysclk__wco__funcs_1ga855b936e5f17dc77abd2c44ec0660e2a">Cy_SysClk_WcoDisable</ref>();</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />the<sp />PILO<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__sysclk__pilo__funcs_1ga4a6570666d4462b97d86e05f4e9fd492">Cy_SysClk_PiloEnable</ref>();</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />the<sp />LFCLK<sp />source<sp />to<sp />the<sp />PILO<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__sysclk__clk__lf__funcs_1ga4d8aaf9e391eafb90aa8897d95525eb4">Cy_SysClk_ClkLfSetSource</ref>(<ref kindref="member" refid="group__group__sysclk__clk__lf__enums_1gga8bfd6f85870f0d30d15e73b3ed820db6a51a3252aefb2b8198451b0d1589e47bf">CY_SYSCLK_CLKLF_IN_PILO</ref>);</highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="1783" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_sysclk.h" bodystart="1776" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_sysclk.h" line="1693" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__sysclk__wco__funcs_1ga7a650a941c2974a9e9298e3e3a6217c1" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>__STATIC_INLINE void</type>
        <definition>__STATIC_INLINE void Cy_SysClk_WcoBypass</definition>
        <argsstring>(cy_en_wco_bypass_modes_t bypass)</argsstring>
        <name>Cy_SysClk_WcoBypass</name>
        <param>
          <type><ref kindref="member" refid="group__group__sysclk__wco__enums_1ga54c5465a9f694e1e71cf1ca2598d2fd7">cy_en_wco_bypass_modes_t</ref></type>
          <declname>bypass</declname>
        </param>
        <briefdescription>
<para>Sets whether the WCO is bypassed or not. </para>        </briefdescription>
        <detaileddescription>
<para>If it is bypassed, then a 32-kHz clock must be provided on the wco_out pin.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>bypass</parametername>
</parameternamelist>
<parameterdescription>
<para><ref kindref="member" refid="group__group__sysclk__wco__enums_1ga54c5465a9f694e1e71cf1ca2598d2fd7">cy_en_wco_bypass_modes_t</ref></para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />An<sp />external<sp />watch<sp />crystal<sp />oscillator<sp />needs<sp />to<sp />be<sp />connected<sp />to</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />the<sp />WCO<sp />pins<sp />instead<sp />of<sp />a<sp />watch<sp />crystal.<sp />This<sp />signal<sp />needs</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />to<sp />source<sp />the<sp />backup<sp />clock<sp />for<sp />the<sp />real-time<sp />clock<sp />operation.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />The<sp />WCO<sp />pins<sp />are<sp />configured<sp />using<sp />the<sp />gpio<sp />driver</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(SRSS_WCO_IN_PIN,<sp />SRSS_WCO_OUT_PIN).<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />WCO<sp />bypassed<sp />mode<sp />-<sp />32768<sp />kHz<sp />square-wave<sp />supplied<sp />through<sp />SRSS_WCO_OUT_PIN<sp />pin<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__sysclk__wco__funcs_1ga7a650a941c2974a9e9298e3e3a6217c1">Cy_SysClk_WcoBypass</ref>(<ref kindref="member" refid="group__group__sysclk__wco__enums_1gga54c5465a9f694e1e71cf1ca2598d2fd7a71a9b78b95df656646dbae3aa9d84329">CY_SYSCLK_WCO_BYPASSED</ref>);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />the<sp />WCO<sp />with<sp />a<sp />timeout<sp />of<sp />2000<sp />microsecond<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__sysclk__returns_1ggad6699a184e2e3c01433251b0981558f3a1563f761f963757b339ff05eb5a690ec">CY_SYSCLK_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__sysclk__wco__funcs_1gac7a1668667e226fd74f782d965b9cd1d">Cy_SysClk_WcoEnable</ref>(2000UL))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Insert<sp />error<sp />handling<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />the<sp />backup<sp />clock<sp />source<sp />to<sp />WCO<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__sysclk__clk__bak__funcs_1ga09031ac63142fe0837f87fb5dabea7a5">Cy_SysClk_ClkBakSetSource</ref>(<ref kindref="member" refid="group__group__sysclk__clk__bak__enums_1ggae43abac127a973232c6e4c1adbde0497a9a82c90148622105cc000167a9b0428b">CY_SYSCLK_BAK_IN_WCO</ref>);</highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="1806" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_sysclk.h" bodystart="1799" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_sysclk.h" line="1694" />
      </memberdef>
      </sectiondef>
    <briefdescription>
    </briefdescription>
    <detaileddescription>
    </detaileddescription>
  </compounddef>
</doxygen>